# add 0x1f000 to all
# A = 0x1, 1 = 0x2, ..., K = 0xe
# spades = 0xa0, hearts = 0xb0, diamonds = 0xc0, clubs = 0xd0
from collections import Counter
import sys
_ = sys.argv[1]
codes = lambda cards: [ord(c) - 0x1f000 for c in cards]
ranks = lambda cards: Counter(c % 0x10 for c in codes(cards))
suits = lambda cards: Counter(c // 0x10 for c in codes(cards))
suitcounts = lambda cards: suits(cards).values()
rankcounts = lambda cards: ranks(cards).values()
rankkeys = lambda cards: set(ranks(cards).keys())
consecutive = lambda cards: rankkeys(cards) == set(range(min(rankkeys(cards)), min(rankkeys(cards))+5))
sameranksmatches = lambda cards, *pattern: Counter(rankcounts(cards)) == Counter(pattern)
# royal flush: 0x1, 0xb-0xe with same second byte
if sameranksmatches(_, 5) and set(rankkeys(_)) == {0x1, 0xa, 0xb, 0xd, 0xe}:
	print("Royal Flush")
# straight flush: same second byte, consec difference is always 0x1
elif sameranksmatches(_, 5) and consecutive(_):
	print("Straight Flush")
# four of a kind: 4 w/ same second byte
elif sameranksmatches(_, 4, 1):
	print("Four of a Kind")
# full house: 3 w/ same second byte, 2 w/ same second byte
elif sameranksmatches(_, 2, 3):
	print("Full House")
# flush: same second byte
elif sameranksmatches(_, 5):
	print("Flush")
# straight: consec difference is always 0x1 (mod 0x10)
elif consecutive(_):
	print("Straight")
# 3 of a kind: 3 w/ same second byte
elif 3 in rankcounts(_):
	print("Three of a Kind")
# two pairs: 2/ same second byte, 2 same second byte
elif sameranksmatches(_, 2, 2, 1):
	print("Two Pair")
# pair: 2 w/ same second byte
elif 2 in rankcounts(_):
	print("Pair")
# high card: else case
else:
	print("High card")
